package com.raditha.megaupload;

import org.apache.struts.upload.DiskMultipartRequestHandler;
import org.apache.struts.upload.MultipartElement;
import org.apache.struts.upload.MultipartRequestWrapper;
import org.apache.struts.upload.DiskFile;

import java.io.*; // i am lazy. ok.
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletException;
import java.util.Hashtable;



public class DiskMultiPartRequestHandler extends DiskMultipartRequestHandler {

    public DiskMultiPartRequestHandler() {
		System.out.println("ho ho ho");
    }


    /**
     * This method populates the internal hashtables with multipart request data.
     * If the request argument is an instance of MultipartRequestWrapper,
     * the request wrapper will be populated as well.
     */
    public void handleRequest(HttpServletRequest request) throws ServletException {

        retrieveTempDir();
        System.out.println("handling request in DiskMultiPartRequestHandler");


		/*
		 * shuck i dont' do nothing it's all MultiPartIterator
		*/
        MultipartIterator iterator = new MultipartIterator(request,
                                                            servlet.getBufferSize(),
                                                            getMaxSizeFromServlet(),
                                                            tempDir);
        MultipartElement element;

        textElements = new Hashtable();
        fileElements = new Hashtable();
        allElements = new Hashtable();

        try {
            while ((element = iterator.getNextElement()) != null) {
                if (!element.isFile()) {

                    if (request instanceof MultipartRequestWrapper) {
                        ((MultipartRequestWrapper) request).setParameter(element.getName(),
                                                                         element.getValue());
                    }
                    String[] textValues = (String[]) textElements.get(element.getName());

                    if (textValues != null) {
                        String[] textValues2 = new String[textValues.length + 1];
                        System.arraycopy(textValues, 0, textValues2, 0, textValues.length);
                        textValues2[textValues.length] = element.getValue();
                        textValues = textValues2;
                    }
                    else {
                        textValues = new String[1];
                        textValues[0] = element.getValue();
                    }
                    textElements.put(element.getName(), textValues);
                    allElements.put(element.getName(), textValues);
                }
                else {

                     File tempFile = element.getFile();
                     if (tempFile.exists()) {
                         DiskFile theFile = new DiskFile(tempFile.getAbsolutePath());
                         theFile.setContentType(element.getContentType());
                         theFile.setFileName(element.getFileName());
                         theFile.setFileSize((int) tempFile.length());
                         fileElements.put(element.getName(), theFile);
                         allElements.put(element.getName(), theFile);
                     }
                }
            }
        }
        catch (UnsupportedEncodingException uee) {
            throw new ServletException("Encoding \"ISO-8859-1\" not supported");
        }

    }

}